# Try to find the GMP librairies
#  GMPXX_FOUND - system has GMPXX lib
#  GMPXX_INCLUDE_DIRS - the GMPXX include directory
#  GMPXX_LIBRARIES - Libraries needed to use GMPXX
#
# Copyright (c) 2013, Marcel Hellwig, <keks@cookiesoft.de>
# Inspired by FindGMP.cmake by Laurent Montel <montel@kde.org>
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING_CMAKE_SCRIPTS file.

find_package(GMP)

if (GMPXX_INCLUDE_DIR AND GMPXX_LIBRARIES)
  # Already in cache, be silent
  set(GMPXX_FIND_QUIETLY TRUE)
endif (GMPXX_INCLUDE_DIR AND GMPXX_LIBRARIES)

find_path(GMPXX_INCLUDE_DIR NAMES gmpxx.h)
find_library(GMPXX_LIBRARIES NAMES gmpxx libgmpxx)

set(GMPXX_INCLUDE_DIRS ${GMPXX_INCLUDE_DIR} ${GMP_INCLUDE_DIR})
set(GMPXX_LIBRARIES ${GMPXX_LIBRARIES} ${GMP_LIBRARIES})

include(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(GMPXX DEFAULT_MSG GMPXX_INCLUDE_DIRS GMPXX_LIBRARIES)

mark_as_advanced(GMPXX_INCLUDE_DIR GMPXX_INCLUDE_DIRS GMPXX_LIBRARIES)
