#include <gmp.h>

void fibonacci(mpz_t out, unsigned int n)
{
    mpz_t last,cur;

    mpz_init_set_ui(last,0);

    if(n==0)
    {
        mpz_swap(out, last);
        mpz_clear(last);
        return;
    }

    mpz_init_set_ui(cur, 1);

    for(unsigned int i = 1; i < n; i++)
    {
        mpz_t tmp;
        mpz_init(tmp);

        mpz_add(tmp,last,cur);
        mpz_swap(last,cur);
        mpz_swap(cur,tmp);
        mpz_clear(tmp);
    }

    mpz_swap(out, cur);
    mpz_clear(cur);
    mpz_clear(last);
}

