#include "maxsubstruct.h"

static MaxSubResult inBetween(int arr[], uint l, uint m, uint u)
{
    MaxSubResult result = { .sum = 0, .start = m, .end = m };

    int sum = 0;
    for (llint i = m; i >= l; i--) {
        sum += arr[i];
        if (sum > result.sum) setSub(&result, sum, i, m);
    }

    sum = result.sum;
    for (llint i = m+1; i <= u; i++) {
        sum += arr[i];
        if (sum > result.sum) setSub(&result, sum, result.start, i);
    }

    return result;
}

static MaxSubResult sub_dc(int arr[], uint l, uint u)
{
    if (l == u)
        return (MaxSubResult){
            .sum = arr[l] > 0 ? arr[l] : 0, .start = l, .end = l
        };

    int m = (u+l) / 2;
    MaxSubResult a = sub_dc(arr, l, m);
    MaxSubResult b = sub_dc(arr, m+1, u);
    MaxSubResult c = inBetween(arr, l, m, u);

    MaxSubResult max = a.sum >= b.sum ? a : b;
    max = max.sum >= c.sum ? max : c;
    return max;
}

MaxSubResult maxSubArray(int arr[], uint length)
{
    if(length != 0)
        return sub_dc(arr, 0, length-1);
    else
        return (MaxSubResult){.sum=0, .start=0, .end=0};
}

